/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qar.h"

extern "C" QplugReturnStatus QarLOG(QplugArgList *);

QplugReturnStatus QarLOG  ( QplugArgList *call_list )

{
QplugReturnStatus	status;
int qar_status;


QdObject_var in_ptr;
QdObject_var out_ptr;

char * attr_ptr;
char * string_buf;
char * out_name;

status = QPLUG_SUCCESS;


//	Unpack the input data objects

 in_ptr = (*call_list)[0];

// Get name of output object

 char * slot_ptr = GetSlotText(0);
 if ( slot_ptr[0] != '\0' ) {
    out_name = QplugNewSTR(slot_ptr);
 }
 else{
    out_name = QplugNewSTR("Log");
    SetSlotText(0,out_name);
 }


// get base SI for input data

  if( QarHasUnits(in_ptr) ){
    // issue warning
    QplugAppendTextDisplay ("WARNING>> Subject has units.\a \n");  
  }


// do arithmetic...


out_ptr = log(in_ptr);

if (out_ptr.is_nil()) {
    QplugAppendTextDisplay (
        "Arithmetic>> Log is not supported between these input types\n");
    return QPLUG_FAILURE; 
}

 // Add timeline if it exists
 
 QdTimeSeq_var tt = get_timetags(in_ptr);
 if (!tt.is_nil()) set_timetags(out_ptr, tt);


 // Set QSAS essential attributes
 
  
   // SI_conversion
   
     // Not meaningfol for a log whatever the inputs
  
   // UNITS
 
      // Not meaningfol for a log whatever the inputs

 // FIELDNAM

   QuSetTxtAttr("FIELDNAM", out_name, out_ptr);
   free (out_name);
 
 // Frame
 
   QuSetTxtAttr("Frame", "scalar>na", out_ptr);
 

  //	..add  the output series to the list

  call_list->push_back(out_ptr);

  QplugAppendTextDisplay ("Logarithm: Done\n");
  
return status;

}

