#include "qOperators.h"


QdObject_var QdPower( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult;

    if ( qdOperand2.is_nil() ||  qdOperand1.is_nil())
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
        return ( qdResult );
    }

	char* attrPtr;
	char* stringBuf;


	// do arithmetic..
	try
	{
		qdResult = pow(qdOperand1, qdOperand2);
		if (qdResult.is_nil())
		{
			QcalcAppendTextDisplay( "Arithmetic>> Power Operation is not yet supported between these input types" );
			rqstrErrorMsg = QString( "Arithmetic>>Power Operation is not yet supported between these input types" );
			return ( qdResult );
		}
	}
	catch( Exception & e)
    {
		e.print_msg();
		QcalcAppendTextDisplay( "Error>> Power operation - Exception thrown..." );
		QcalcAppendTextDisplay( e.msg().c_str() );
		rqstrErrorMsg = QString( "Error>> Power - Exception thrown..." );
		return ( qdResult );
    }


	// Add timeline: Either timeline is safe if it exists
	QdTimeSeq_var qdtt = get_timetags( qdOperand1 );
	if ( qdtt.is_nil() )
	{
		qdtt = get_timetags( qdOperand2 );
	}

	if ( !qdtt.is_nil() )
	{
		set_timetags( qdResult, qdtt );
	}

	// Set QSAS essential attributes
	QdRScalar_var qdrBPtr = QdRScalar_var::narrow( qdOperand2 );
	if ( !qdrBPtr.is_nil() )
	{
		// can only do these if power is unique
		// SI_conversion
		// the value for constant power is a global
		double dConstB = ( double )( *qdrBPtr );
		if( ( attrPtr = QarSIConv_power( qdOperand1, dConstB ) ) != NULL )
		{
			QuSetTxtAttr( "SI_conversion", attrPtr, qdResult );
			delete[] attrPtr;
		}

		// UNITS
		// the value for constant power is a global
		if( ( attrPtr = QarUNITS_power( qdOperand1, dConstB ) ) != NULL )
		{
			QuSetTxtAttr( "UNITS", attrPtr, qdResult );
			delete[] attrPtr;
		}

	}


	// Frame
	QuSetFrame( qdResult, "scalar" );


    return ( qdResult );
}

