#include <qsize.h>
#include "qcalc.h"
#include "qwui.h"


using namespace QSAS;


QcalcWindow * QCALCmakeWindow( QWidget *parent, const char * Title )
{
  if ( QCALC_widget == NULL )
  {
		QCALC_widget = new QcalcWindow( parent,Title );

		QCALC_widget->connect( parent, SIGNAL( saveSessionRequest( QString ) ), QCALC_widget, SLOT( saveSession(    QString ) ) );
		QCALC_widget->connect( parent, SIGNAL( restoreSessionRequest( QString ) ),   QCALC_widget, SLOT( restoreSession( QString ) ) );
		QCALC_widget->connect( parent, SIGNAL( clearListRequest() ),   QCALC_widget->_join_listview, SLOT( deleteAllItems() ) );
		QCALC_widget->setCaption( Title) ;
#if QT_VERSION < 0x040000
		QCALC_widget->JoinBtn = new QPushButton( "Do", QCALC_widget->buttons_layout, "JoinBtn" );
		QCALC_widget->JoinBtn->setFocusPolicy( STRONG_FOCUS );
		QCALC_widget->JoinBtn->setMinimumSize( QCALC_widget->JoinBtn->sizeHint() );
		QCALC_widget->connect( QCALC_widget->JoinBtn, SIGNAL(clicked()), QCALC_widget,   SLOT( DoCalculation() ) );
		QCALC_widget->buttons_layout->addSpace( 0 );

		QCALC_widget->newCalcBtn = new QPushButton( "New Operation", QCALC_widget->buttons_layout, "NewCalcBtn" );
		QCALC_widget->newCalcBtn->setFocusPolicy( STRONG_FOCUS );
		QCALC_widget->newCalcBtn->setMinimumSize( QCALC_widget->newCalcBtn->sizeHint() );
		QCALC_widget->connect( QCALC_widget->newCalcBtn, SIGNAL(clicked()), QCALC_widget->_join_listview, SLOT( insertVirtualItem() ) );
		QCALC_widget->buttons_layout->addSpace( 0 );

		QCALC_widget->dismissBtn = new QPushButton( "Dismiss",  QCALC_widget->buttons_layout, "dismissBtn" );
		QCALC_widget->dismissBtn->setMinimumSize(QCALC_widget->dismissBtn->sizeHint());
		QCALC_widget->connect( QCALC_widget->dismissBtn, SIGNAL(clicked()), QCALC_widget, SLOT( close() ) );
#else
		QCALC_widget->JoinBtn = new QPushButton( "Do", QCALC_widget->buttons_groupbox, "JoinBtn" );
		QCALC_widget->JoinBtn->setFocusPolicy( STRONG_FOCUS );
		QCALC_widget->JoinBtn->setMinimumSize( QCALC_widget->JoinBtn->sizeHint() );
		QCALC_widget->connect( QCALC_widget->JoinBtn, SIGNAL(clicked()), QCALC_widget,   SLOT( DoCalculation() ) );
		QCALC_widget->buttons_groupbox->layout()->addWidget(QCALC_widget->JoinBtn);

		QCALC_widget->newCalcBtn = new QPushButton( "New Operation", QCALC_widget->buttons_groupbox, "NewCalcBtn" );
		QCALC_widget->newCalcBtn->setFocusPolicy( STRONG_FOCUS );
		QCALC_widget->newCalcBtn->setMinimumSize( QCALC_widget->newCalcBtn->sizeHint() );
		QCALC_widget->connect( QCALC_widget->newCalcBtn, SIGNAL(clicked()), QCALC_widget->_join_listview, SLOT( insertVirtualItem() ) );
		QCALC_widget->buttons_groupbox->layout()->addWidget(QCALC_widget->newCalcBtn);

		QCALC_widget->dismissBtn = new QPushButton( "Dismiss",  QCALC_widget->buttons_groupbox, "dismissBtn" );
		QCALC_widget->dismissBtn->setMinimumSize(QCALC_widget->dismissBtn->sizeHint());
		QCALC_widget->connect( QCALC_widget->dismissBtn, SIGNAL(clicked()), QCALC_widget, SLOT( close() ) );
		QCALC_widget->buttons_groupbox->layout()->addWidget(QCALC_widget->dismissBtn);
#endif
		QCALC_widget->_filename += QString("/saveSet");
		QCALC_widget->SAVE_EXTENSION = QString(".qs_calc");
		QCALC_widget->_filename += QCALC_widget->SAVE_EXTENSION;
		QCALC_widget->_saveset_filter=QString("calculator savesets (*.qs_calc)");
  }
 
  QCALC_widget->setAcceptDrops(TRUE);
  return QCALC_widget;

}

void QCEXPmakeWindow( QWidget *parent, const char * Title )
{
  if ( QCEX_widget == NULL )
  {
		QCEX_widget = new QcalcWindow( parent,Title );
		QCEX_widget->connect( parent, SIGNAL( saveSessionRequest( QString ) ), QCEX_widget, SLOT( saveSession(    QString ) ) );
		QCEX_widget->connect( parent, SIGNAL( restoreSessionRequest( QString ) ),   QCEX_widget, SLOT( restoreSession( QString ) ) );
		QCEX_widget->connect( parent, SIGNAL( clearListRequest() ),   QCEX_widget->_join_listview, SLOT( deleteAllItems() )  );
     QCEX_widget->setCaption(Title);
     
#if QT_VERSION < 0x040000
     QCEX_widget->WriteBtn = new QPushButton( "Export...", QCEX_widget->buttons_layout, "WriteBtn" );
     QCEX_widget->WriteBtn->setMinimumSize(QCEX_widget->WriteBtn->sizeHint());
     QCEX_widget->connect( QCEX_widget->WriteBtn, SIGNAL(clicked()),  QCEX_widget, SLOT(writeFile()) );
     QCEX_widget->buttons_layout->addSpace(0);
     QCEX_widget->dismissBtn = new QPushButton( "Dismiss", QCEX_widget->buttons_layout, "dismissBtn" );
     QCEX_widget->dismissBtn->setMinimumSize(QCEX_widget->dismissBtn->sizeHint());
     QCEX_widget->connect( QCEX_widget->dismissBtn, SIGNAL(clicked()), QCEX_widget, SLOT(close()) );
#else
     QCEX_widget->WriteBtn = new QPushButton( "Export...", QCEX_widget->buttons_groupbox, "WriteBtn" );
     QCEX_widget->WriteBtn->setMinimumSize(QCEX_widget->WriteBtn->sizeHint());
     QCEX_widget->connect( QCEX_widget->WriteBtn, SIGNAL(clicked()),  QCEX_widget, SLOT(writeFile()) );
     QCEX_widget->buttons_groupbox->layout()->addWidget(QCEX_widget->WriteBtn);

     QCEX_widget->dismissBtn = new QPushButton( "Dismiss", QCEX_widget->buttons_groupbox, "dismissBtn" );
     QCEX_widget->dismissBtn->setMinimumSize(QCEX_widget->dismissBtn->sizeHint());
     QCEX_widget->connect( QCEX_widget->dismissBtn, SIGNAL(clicked()), QCEX_widget, SLOT(close()) );
     QCEX_widget->buttons_groupbox->layout()->addWidget(QCEX_widget->dismissBtn);
#endif

     QCEX_widget->_filename += QString("/saveSet");
     QCEX_widget->SAVE_EXTENSION = QString(".qs_export");
     QCEX_widget->_filename += QCEX_widget->SAVE_EXTENSION;
	QCEX_widget->_saveset_filter=QString("export savesets (*.qs_export)");
  }

  return;
}

void QcalcShowExport()
{
//  QSize qsasGUISize = qsasWindow->frameSize();
//  QCEX_widget->move(qsasGUISize.width(),30);
  // QCEX_widget->show();
}

void QcalcShowCalc()
{	
  QCALC_widget->move(qsasGUISize().width(), 50);
  
  QCALC_widget->JoinBtn->setDefault( true );
  QCALC_widget->newCalcBtn->setDefault( false );
  QCALC_widget->dismissBtn->setDefault( false );

  QCALC_widget->show();
}



void QcalcAppendTextDisplay ( const char *text )
{
	if ( QCALC_widget == NULL )
	{

      QuMsgBar( "Calculator error, see console ", true );
      return;
    }

	if ( QCALC_widget->logArea == NULL )
	{
     	QuMsgBar( "Calculator error, see console ", true );
     	return;
	}

    QCALC_widget->logArea->append( text );
}


