/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "qdutil.h"
#include "Qdos.h"

//**************************************************************************

#define QPAL_DEBUG  0   // print out debug info as label is constructed

//**************************************************************************
//**************************************************************************


char* QpAxisLabelMakeStem (QdObject_var data_obj)

{
  char *stem_ptr;
  static char stem_buf[300] = "\0";

  //  For the stem, use LABLAXIS attribute if it exists, else try for
  //  LABL_PTR (may exist for vector data objects) and perform string
  //  comparision on its entries to synthesise a stem from common parts.
  //  If neither LABLAXIS nor LABL_PTR_1 exists, try for FIELDNAM attribute,
  //  and if that is absent finally fall back to data object name itself.


  //  first use LABLAXIS attribute if it exists

  stem_ptr = QuGetAttrText("LABLAXIS", data_obj);

  if(strcmp(stem_ptr, "") != 0){
    if (QPAL_DEBUG)
	{
      printf ("QpAxisLabelMakeStem: using LABLAXIS = /%s/\n", stem_ptr);
	  fflush(stdout);
	}

    strcpy (stem_buf, stem_ptr);

  } 
  else {
    stem_ptr = QuGetAttrText("FIELDNAM", data_obj);

  // fall back to using FIELDNAM attribute if it exists

    if (QPAL_DEBUG)
	{
      printf("QpAxisLabelMakeStem: using FIELDNAM = /%s/\n", stem_ptr);
	  fflush(stdout);
	}

    strcpy (stem_buf, stem_ptr);

  }


  return stem_buf;

}

//**************************************************************************
//**************************************************************************

