#include "PathConfig.h"

PathConfig::PathConfig()
{
	QGridLayout * layout=new QGridLayout(this);
	
	layout->setSpacing(QSAS_profiles->current()->GUImargins);
	layout->setMargin(QSAS_profiles->current()->GUImargins);
	
	QLabel * tempLabel=new QLabel("Save/Restore default path*", this);
#if QT_VERSION >= 0x040000
	tempLabel->setWordWrap(true);
#endif
	layout->addWidget(tempLabel, 0, 0);
	
	saveRestoreLine=new QLineEdit(this);
	layout->addWidget(saveRestoreLine, 0, 1);
	
	QPushButton* saveRestoreButton=new QPushButton("Browse", this);
	connect(saveRestoreButton, SIGNAL(clicked()), this, SLOT(saveRestorePressed()));
	layout->addWidget(saveRestoreButton, 0, 2);
	
	tempLabel=new QLabel("User-defined libraries directory*", this);
#if QT_VERSION >= 0x040000
	tempLabel->setWordWrap(true);
#endif
	layout->addWidget(tempLabel, 1, 0);
	
	userLine=new QLineEdit(this);
	layout->addWidget(userLine, 1, 1);
	
	QPushButton* userButton=new QPushButton("Browse", this);
	connect(userButton, SIGNAL(clicked()), this, SLOT(userPressed()));
	layout->addWidget(userButton, 1, 2);
	
	tempLabel=new QLabel("Default directory for Database map files*", this);
#if QT_VERSION >= 0x040000
	tempLabel->setWordWrap(true);
#endif
	layout->addWidget(tempLabel, 2, 0);
	
	configLine=new QLineEdit(this);
	layout->addWidget(configLine, 2, 1);
	
	QPushButton* configButton=new QPushButton("Browse", this);
	connect(configButton, SIGNAL(clicked()), this, SLOT(configPressed()));
	layout->addWidget(configButton, 2, 2);
	
	tempLabel=new QLabel("Filter bank directory for DWT plug-in", this);
#if QT_VERSION >= 0x040000
	tempLabel->setWordWrap(true);
#endif
	layout->addWidget(tempLabel, 3, 0);
	
	filterBankLine=new QLineEdit(this);
	layout->addWidget(filterBankLine, 3, 1);
	
	QPushButton* filterBankButton=new QPushButton("Browse", this);
	connect(filterBankButton, SIGNAL(clicked()), this, SLOT(filterBankPressed()));
	layout->addWidget(filterBankButton, 3, 2);
}

void PathConfig::updateProfile(QProfile* prof)
{
	prof->SaveRestorePath=saveRestoreLine->text();
	prof->UserLibPath=userLine->text();
	prof->ConfigPath=configLine->text();
	prof->FilterBankPath=filterBankLine->text();
}

void PathConfig::setSelectedProfile(QProfile* prof)
{
	saveRestoreLine->setText(prof->SaveRestorePath);
	userLine->setText(prof->UserLibPath);
	configLine->setText(prof->ConfigPath);
	filterBankLine->setText(prof->FilterBankPath);
}

void PathConfig::saveRestorePressed()
{
#if QT_VERSION < 0x040000
	QString res=QFileDialog::getExistingDirectory(saveRestoreLine->text(), this, "Select Save/Restore Directory",  "Select Save/Restore Directory", TRUE );
#else
	QString res=QFileDialog::getExistingDirectory(this, "Select Save/Restore Directory", saveRestoreLine->text(), QFileDialog::ShowDirsOnly );
#endif
	if(!res.isEmpty()) saveRestoreLine->setText(res);
}

void PathConfig::userPressed()
{
#if QT_VERSION < 0x040000
	QString res=QFileDialog::getExistingDirectory(userLine->text(), this, "Select User-Defined Libraries Directory",  "Select User-Defined Libraries Directory", TRUE );
#else
	QString res=QFileDialog::getExistingDirectory(this, "Select User-Defined Libraries Directory", userLine->text(), QFileDialog::ShowDirsOnly );
#endif
	if(!res.isEmpty()) userLine->setText(res);
}

void PathConfig::configPressed()
{
#if QT_VERSION < 0x040000
	QString res=QFileDialog::getExistingDirectory(configLine->text(), this, "Select DB default Directory",  "Select DB default Directory", TRUE );
#else
	QString res=QFileDialog::getExistingDirectory(this, "Select DB default Directory", configLine->text(), QFileDialog::ShowDirsOnly );
#endif
	if(!res.isEmpty()) configLine->setText(res);
}

void PathConfig::filterBankPressed()
{
#if QT_VERSION < 0x040000
	QString res=QFileDialog::getExistingDirectory(filterBankLine->text(), this, "Select Filter Bank Directory",  "Select Filter Bank Directory", TRUE );
#else
	QString res=QFileDialog::getExistingDirectory(this, "Select Filter Bank Directory", filterBankLine->text(), QFileDialog::ShowDirsOnly );
#endif
	if(!res.isEmpty()) filterBankLine->setText(res);
}
